#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;

typedef struct Script Script;
struct Script
{
	int numNames;
	char (*names)[24];
	int mainEnd;
	int largest;
	int numMissions;
	int numExclusive;
	int mainOffset;
	int *missionOffsets;

	uchar *buf;
	int bufSize;
};


// arg types:
//   1 int
//   2 float
//   3 var_int
//   4 var_float
//   5 var_int_opt
//   6 var_float_opt
//   7 lvar_int
//   8 lvar_float
//   9 lvar_int_opt
//   A lvar_float_opt
//   B varargs (int, float, var/lvar)
//   C any int
//   D any float
//   E any int writable
//   F any float writable
//  10 label
//  12 textlabel
//  13 var_textlabel
//  14 lvar_textlabel
//  15 var_textlabel_opt
//  16 lvar_textlabel_opt
//  17 string

// binary types
// 1 long
// 2 global variable
// 3 local variable
// 4 byte
// 5 word
// 6 float

enum CompiledType {
	Long = 1,
	Global,
	Local,
	Byte,
	Word,
	Float
};

typedef struct Command Command;
struct Command
{
	uchar supported;
	char name[48];
	uchar args[18];
};

extern Command commands[0x5C3];
